# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class Adjacents(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        Adjacents - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'superiors': 'list[User]',
            'siblings': 'list[User]',
            'direct_reports': 'list[User]'
        }

        self.attribute_map = {
            'superiors': 'superiors',
            'siblings': 'siblings',
            'direct_reports': 'directReports'
        }

        self._superiors = None
        self._siblings = None
        self._direct_reports = None

    @property
    def superiors(self):
        """
        Gets the superiors of this Adjacents.


        :return: The superiors of this Adjacents.
        :rtype: list[User]
        """
        return self._superiors

    @superiors.setter
    def superiors(self, superiors):
        """
        Sets the superiors of this Adjacents.


        :param superiors: The superiors of this Adjacents.
        :type: list[User]
        """
        
        self._superiors = superiors

    @property
    def siblings(self):
        """
        Gets the siblings of this Adjacents.


        :return: The siblings of this Adjacents.
        :rtype: list[User]
        """
        return self._siblings

    @siblings.setter
    def siblings(self, siblings):
        """
        Sets the siblings of this Adjacents.


        :param siblings: The siblings of this Adjacents.
        :type: list[User]
        """
        
        self._siblings = siblings

    @property
    def direct_reports(self):
        """
        Gets the direct_reports of this Adjacents.


        :return: The direct_reports of this Adjacents.
        :rtype: list[User]
        """
        return self._direct_reports

    @direct_reports.setter
    def direct_reports(self, direct_reports):
        """
        Sets the direct_reports of this Adjacents.


        :param direct_reports: The direct_reports of this Adjacents.
        :type: list[User]
        """
        
        self._direct_reports = direct_reports

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

