# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class AgentTimeOffRequestPatch(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        AgentTimeOffRequestPatch - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'marked_as_read': 'bool',
            'status': 'str',
            'notes': 'str'
        }

        self.attribute_map = {
            'marked_as_read': 'markedAsRead',
            'status': 'status',
            'notes': 'notes'
        }

        self._marked_as_read = None
        self._status = None
        self._notes = None

    @property
    def marked_as_read(self):
        """
        Gets the marked_as_read of this AgentTimeOffRequestPatch.
        Whether this request has been read by the agent

        :return: The marked_as_read of this AgentTimeOffRequestPatch.
        :rtype: bool
        """
        return self._marked_as_read

    @marked_as_read.setter
    def marked_as_read(self, marked_as_read):
        """
        Sets the marked_as_read of this AgentTimeOffRequestPatch.
        Whether this request has been read by the agent

        :param marked_as_read: The marked_as_read of this AgentTimeOffRequestPatch.
        :type: bool
        """
        
        self._marked_as_read = marked_as_read

    @property
    def status(self):
        """
        Gets the status of this AgentTimeOffRequestPatch.
        The status of this time off request. Can only be canceled if the requested date has not already passed

        :return: The status of this AgentTimeOffRequestPatch.
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """
        Sets the status of this AgentTimeOffRequestPatch.
        The status of this time off request. Can only be canceled if the requested date has not already passed

        :param status: The status of this AgentTimeOffRequestPatch.
        :type: str
        """
        allowed_values = ["CANCELED"]
        if status.lower() not in map(str.lower, allowed_values):
            # print "Invalid value for status -> " + status
            self._status = "outdated_sdk_version"
        else:
            self._status = status

    @property
    def notes(self):
        """
        Gets the notes of this AgentTimeOffRequestPatch.
        Notes about the time off request. Can only be edited while the request is still pending

        :return: The notes of this AgentTimeOffRequestPatch.
        :rtype: str
        """
        return self._notes

    @notes.setter
    def notes(self, notes):
        """
        Sets the notes of this AgentTimeOffRequestPatch.
        Notes about the time off request. Can only be edited while the request is still pending

        :param notes: The notes of this AgentTimeOffRequestPatch.
        :type: str
        """
        
        self._notes = notes

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

