# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class ConsultTransferUpdate(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        ConsultTransferUpdate - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'speak_to': 'str'
        }

        self.attribute_map = {
            'speak_to': 'speakTo'
        }

        self._speak_to = None

    @property
    def speak_to(self):
        """
        Gets the speak_to of this ConsultTransferUpdate.
        Determines to whom the initiating participant is speaking.

        :return: The speak_to of this ConsultTransferUpdate.
        :rtype: str
        """
        return self._speak_to

    @speak_to.setter
    def speak_to(self, speak_to):
        """
        Sets the speak_to of this ConsultTransferUpdate.
        Determines to whom the initiating participant is speaking.

        :param speak_to: The speak_to of this ConsultTransferUpdate.
        :type: str
        """
        allowed_values = ["DESTINATION", "OBJECT", "BOTH"]
        if speak_to.lower() not in map(str.lower, allowed_values):
            # print "Invalid value for speak_to -> " + speak_to
            self._speak_to = "outdated_sdk_version"
        else:
            self._speak_to = speak_to

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

