# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class MessageMediaAttachment(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        MessageMediaAttachment - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'url': 'str',
            'media_type': 'str',
            'content_length': 'int',
            'name': 'str',
            'id': 'str'
        }

        self.attribute_map = {
            'url': 'url',
            'media_type': 'mediaType',
            'content_length': 'contentLength',
            'name': 'name',
            'id': 'id'
        }

        self._url = None
        self._media_type = None
        self._content_length = None
        self._name = None
        self._id = None

    @property
    def url(self):
        """
        Gets the url of this MessageMediaAttachment.
        The location of the media, useful for retrieving it

        :return: The url of this MessageMediaAttachment.
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """
        Sets the url of this MessageMediaAttachment.
        The location of the media, useful for retrieving it

        :param url: The url of this MessageMediaAttachment.
        :type: str
        """
        
        self._url = url

    @property
    def media_type(self):
        """
        Gets the media_type of this MessageMediaAttachment.
        The optional internet media type of the the media object.If null then the media type should be dictated by the url.

        :return: The media_type of this MessageMediaAttachment.
        :rtype: str
        """
        return self._media_type

    @media_type.setter
    def media_type(self, media_type):
        """
        Sets the media_type of this MessageMediaAttachment.
        The optional internet media type of the the media object.If null then the media type should be dictated by the url.

        :param media_type: The media_type of this MessageMediaAttachment.
        :type: str
        """
        allowed_values = ["image/png", "image/jpeg", "image/gif"]
        if media_type.lower() not in map(str.lower, allowed_values):
            # print "Invalid value for media_type -> " + media_type
            self._media_type = "outdated_sdk_version"
        else:
            self._media_type = media_type

    @property
    def content_length(self):
        """
        Gets the content_length of this MessageMediaAttachment.
        The optional content length of the the media object, in bytes.

        :return: The content_length of this MessageMediaAttachment.
        :rtype: int
        """
        return self._content_length

    @content_length.setter
    def content_length(self, content_length):
        """
        Sets the content_length of this MessageMediaAttachment.
        The optional content length of the the media object, in bytes.

        :param content_length: The content_length of this MessageMediaAttachment.
        :type: int
        """
        
        self._content_length = content_length

    @property
    def name(self):
        """
        Gets the name of this MessageMediaAttachment.


        :return: The name of this MessageMediaAttachment.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this MessageMediaAttachment.


        :param name: The name of this MessageMediaAttachment.
        :type: str
        """
        
        self._name = name

    @property
    def id(self):
        """
        Gets the id of this MessageMediaAttachment.


        :return: The id of this MessageMediaAttachment.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this MessageMediaAttachment.


        :param id: The id of this MessageMediaAttachment.
        :type: str
        """
        
        self._id = id

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

