# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class MetaData(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        MetaData - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'pairing_token': 'str',
            'pairing_trust': 'list[str]',
            'pairing_url': 'str'
        }

        self.attribute_map = {
            'pairing_token': 'pairing-token',
            'pairing_trust': 'pairing-trust',
            'pairing_url': 'pairing-url'
        }

        self._pairing_token = None
        self._pairing_trust = None
        self._pairing_url = None

    @property
    def pairing_token(self):
        """
        Gets the pairing_token of this MetaData.


        :return: The pairing_token of this MetaData.
        :rtype: str
        """
        return self._pairing_token

    @pairing_token.setter
    def pairing_token(self, pairing_token):
        """
        Sets the pairing_token of this MetaData.


        :param pairing_token: The pairing_token of this MetaData.
        :type: str
        """
        
        self._pairing_token = pairing_token

    @property
    def pairing_trust(self):
        """
        Gets the pairing_trust of this MetaData.


        :return: The pairing_trust of this MetaData.
        :rtype: list[str]
        """
        return self._pairing_trust

    @pairing_trust.setter
    def pairing_trust(self, pairing_trust):
        """
        Sets the pairing_trust of this MetaData.


        :param pairing_trust: The pairing_trust of this MetaData.
        :type: list[str]
        """
        
        self._pairing_trust = pairing_trust

    @property
    def pairing_url(self):
        """
        Gets the pairing_url of this MetaData.


        :return: The pairing_url of this MetaData.
        :rtype: str
        """
        return self._pairing_url

    @pairing_url.setter
    def pairing_url(self, pairing_url):
        """
        Sets the pairing_url of this MetaData.


        :param pairing_url: The pairing_url of this MetaData.
        :type: str
        """
        
        self._pairing_url = pairing_url

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

