# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class QueueConversationScreenShareEventTopicConversationRoutingData(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        QueueConversationScreenShareEventTopicConversationRoutingData - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'queue': 'QueueConversationScreenShareEventTopicUriReference',
            'language': 'QueueConversationScreenShareEventTopicUriReference',
            'priority': 'int',
            'skills': 'list[QueueConversationScreenShareEventTopicUriReference]',
            'scored_agents': 'list[QueueConversationScreenShareEventTopicScoredAgent]'
        }

        self.attribute_map = {
            'queue': 'queue',
            'language': 'language',
            'priority': 'priority',
            'skills': 'skills',
            'scored_agents': 'scoredAgents'
        }

        self._queue = None
        self._language = None
        self._priority = None
        self._skills = None
        self._scored_agents = None

    @property
    def queue(self):
        """
        Gets the queue of this QueueConversationScreenShareEventTopicConversationRoutingData.


        :return: The queue of this QueueConversationScreenShareEventTopicConversationRoutingData.
        :rtype: QueueConversationScreenShareEventTopicUriReference
        """
        return self._queue

    @queue.setter
    def queue(self, queue):
        """
        Sets the queue of this QueueConversationScreenShareEventTopicConversationRoutingData.


        :param queue: The queue of this QueueConversationScreenShareEventTopicConversationRoutingData.
        :type: QueueConversationScreenShareEventTopicUriReference
        """
        
        self._queue = queue

    @property
    def language(self):
        """
        Gets the language of this QueueConversationScreenShareEventTopicConversationRoutingData.


        :return: The language of this QueueConversationScreenShareEventTopicConversationRoutingData.
        :rtype: QueueConversationScreenShareEventTopicUriReference
        """
        return self._language

    @language.setter
    def language(self, language):
        """
        Sets the language of this QueueConversationScreenShareEventTopicConversationRoutingData.


        :param language: The language of this QueueConversationScreenShareEventTopicConversationRoutingData.
        :type: QueueConversationScreenShareEventTopicUriReference
        """
        
        self._language = language

    @property
    def priority(self):
        """
        Gets the priority of this QueueConversationScreenShareEventTopicConversationRoutingData.


        :return: The priority of this QueueConversationScreenShareEventTopicConversationRoutingData.
        :rtype: int
        """
        return self._priority

    @priority.setter
    def priority(self, priority):
        """
        Sets the priority of this QueueConversationScreenShareEventTopicConversationRoutingData.


        :param priority: The priority of this QueueConversationScreenShareEventTopicConversationRoutingData.
        :type: int
        """
        
        self._priority = priority

    @property
    def skills(self):
        """
        Gets the skills of this QueueConversationScreenShareEventTopicConversationRoutingData.


        :return: The skills of this QueueConversationScreenShareEventTopicConversationRoutingData.
        :rtype: list[QueueConversationScreenShareEventTopicUriReference]
        """
        return self._skills

    @skills.setter
    def skills(self, skills):
        """
        Sets the skills of this QueueConversationScreenShareEventTopicConversationRoutingData.


        :param skills: The skills of this QueueConversationScreenShareEventTopicConversationRoutingData.
        :type: list[QueueConversationScreenShareEventTopicUriReference]
        """
        
        self._skills = skills

    @property
    def scored_agents(self):
        """
        Gets the scored_agents of this QueueConversationScreenShareEventTopicConversationRoutingData.


        :return: The scored_agents of this QueueConversationScreenShareEventTopicConversationRoutingData.
        :rtype: list[QueueConversationScreenShareEventTopicScoredAgent]
        """
        return self._scored_agents

    @scored_agents.setter
    def scored_agents(self, scored_agents):
        """
        Sets the scored_agents of this QueueConversationScreenShareEventTopicConversationRoutingData.


        :param scored_agents: The scored_agents of this QueueConversationScreenShareEventTopicConversationRoutingData.
        :type: list[QueueConversationScreenShareEventTopicScoredAgent]
        """
        
        self._scored_agents = scored_agents

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

