# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class SharedResponse(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        SharedResponse - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'id': 'str',
            'download_uri': 'str',
            'view_uri': 'str',
            'document': 'Document',
            'share': 'Share'
        }

        self.attribute_map = {
            'id': 'id',
            'download_uri': 'downloadUri',
            'view_uri': 'viewUri',
            'document': 'document',
            'share': 'share'
        }

        self._id = None
        self._download_uri = None
        self._view_uri = None
        self._document = None
        self._share = None

    @property
    def id(self):
        """
        Gets the id of this SharedResponse.


        :return: The id of this SharedResponse.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this SharedResponse.


        :param id: The id of this SharedResponse.
        :type: str
        """
        
        self._id = id

    @property
    def download_uri(self):
        """
        Gets the download_uri of this SharedResponse.


        :return: The download_uri of this SharedResponse.
        :rtype: str
        """
        return self._download_uri

    @download_uri.setter
    def download_uri(self, download_uri):
        """
        Sets the download_uri of this SharedResponse.


        :param download_uri: The download_uri of this SharedResponse.
        :type: str
        """
        
        self._download_uri = download_uri

    @property
    def view_uri(self):
        """
        Gets the view_uri of this SharedResponse.


        :return: The view_uri of this SharedResponse.
        :rtype: str
        """
        return self._view_uri

    @view_uri.setter
    def view_uri(self, view_uri):
        """
        Sets the view_uri of this SharedResponse.


        :param view_uri: The view_uri of this SharedResponse.
        :type: str
        """
        
        self._view_uri = view_uri

    @property
    def document(self):
        """
        Gets the document of this SharedResponse.


        :return: The document of this SharedResponse.
        :rtype: Document
        """
        return self._document

    @document.setter
    def document(self, document):
        """
        Sets the document of this SharedResponse.


        :param document: The document of this SharedResponse.
        :type: Document
        """
        
        self._document = document

    @property
    def share(self):
        """
        Gets the share of this SharedResponse.


        :return: The share of this SharedResponse.
        :rtype: Share
        """
        return self._share

    @share.setter
    def share(self, share):
        """
        Sets the share of this SharedResponse.


        :param share: The share of this SharedResponse.
        :type: Share
        """
        
        self._share = share

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

