# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class ShortTermForecastListItemResponse(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        ShortTermForecastListItemResponse - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'id': 'str',
            'week_date': 'str',
            'description': 'str',
            'creation_method': 'str',
            'metadata': 'WfmVersionedEntityMetadata',
            'self_uri': 'str'
        }

        self.attribute_map = {
            'id': 'id',
            'week_date': 'weekDate',
            'description': 'description',
            'creation_method': 'creationMethod',
            'metadata': 'metadata',
            'self_uri': 'selfUri'
        }

        self._id = None
        self._week_date = None
        self._description = None
        self._creation_method = None
        self._metadata = None
        self._self_uri = None

    @property
    def id(self):
        """
        Gets the id of this ShortTermForecastListItemResponse.
        The id of the short term forecast

        :return: The id of this ShortTermForecastListItemResponse.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this ShortTermForecastListItemResponse.
        The id of the short term forecast

        :param id: The id of this ShortTermForecastListItemResponse.
        :type: str
        """
        
        self._id = id

    @property
    def week_date(self):
        """
        Gets the week_date of this ShortTermForecastListItemResponse.
        The weekDate of the short term forecast in yyyy-MM-dd format

        :return: The week_date of this ShortTermForecastListItemResponse.
        :rtype: str
        """
        return self._week_date

    @week_date.setter
    def week_date(self, week_date):
        """
        Sets the week_date of this ShortTermForecastListItemResponse.
        The weekDate of the short term forecast in yyyy-MM-dd format

        :param week_date: The week_date of this ShortTermForecastListItemResponse.
        :type: str
        """
        
        self._week_date = week_date

    @property
    def description(self):
        """
        Gets the description of this ShortTermForecastListItemResponse.
        The description of the short term forecast

        :return: The description of this ShortTermForecastListItemResponse.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this ShortTermForecastListItemResponse.
        The description of the short term forecast

        :param description: The description of this ShortTermForecastListItemResponse.
        :type: str
        """
        
        self._description = description

    @property
    def creation_method(self):
        """
        Gets the creation_method of this ShortTermForecastListItemResponse.
        The method used to create this forecast

        :return: The creation_method of this ShortTermForecastListItemResponse.
        :rtype: str
        """
        return self._creation_method

    @creation_method.setter
    def creation_method(self, creation_method):
        """
        Sets the creation_method of this ShortTermForecastListItemResponse.
        The method used to create this forecast

        :param creation_method: The creation_method of this ShortTermForecastListItemResponse.
        :type: str
        """
        allowed_values = ["Import", "HistoricalWeightedAverage", "Advanced"]
        if creation_method.lower() not in map(str.lower, allowed_values):
            # print "Invalid value for creation_method -> " + creation_method
            self._creation_method = "outdated_sdk_version"
        else:
            self._creation_method = creation_method

    @property
    def metadata(self):
        """
        Gets the metadata of this ShortTermForecastListItemResponse.
        Metadata for this forecast

        :return: The metadata of this ShortTermForecastListItemResponse.
        :rtype: WfmVersionedEntityMetadata
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """
        Sets the metadata of this ShortTermForecastListItemResponse.
        Metadata for this forecast

        :param metadata: The metadata of this ShortTermForecastListItemResponse.
        :type: WfmVersionedEntityMetadata
        """
        
        self._metadata = metadata

    @property
    def self_uri(self):
        """
        Gets the self_uri of this ShortTermForecastListItemResponse.
        The URI for this object

        :return: The self_uri of this ShortTermForecastListItemResponse.
        :rtype: str
        """
        return self._self_uri

    @self_uri.setter
    def self_uri(self, self_uri):
        """
        Sets the self_uri of this ShortTermForecastListItemResponse.
        The URI for this object

        :param self_uri: The self_uri of this ShortTermForecastListItemResponse.
        :type: str
        """
        
        self._self_uri = self_uri

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

