# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class ShrinkageOverrides(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        ShrinkageOverrides - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'clear': 'bool',
            'values': 'list[ShrinkageOverride]'
        }

        self.attribute_map = {
            'clear': 'clear',
            'values': 'values'
        }

        self._clear = None
        self._values = None

    @property
    def clear(self):
        """
        Gets the clear of this ShrinkageOverrides.
        Set true to clear the shrinkage interval overrides

        :return: The clear of this ShrinkageOverrides.
        :rtype: bool
        """
        return self._clear

    @clear.setter
    def clear(self, clear):
        """
        Sets the clear of this ShrinkageOverrides.
        Set true to clear the shrinkage interval overrides

        :param clear: The clear of this ShrinkageOverrides.
        :type: bool
        """
        
        self._clear = clear

    @property
    def values(self):
        """
        Gets the values of this ShrinkageOverrides.
        List of interval shrinkage overrides

        :return: The values of this ShrinkageOverrides.
        :rtype: list[ShrinkageOverride]
        """
        return self._values

    @values.setter
    def values(self, values):
        """
        Sets the values of this ShrinkageOverrides.
        List of interval shrinkage overrides

        :param values: The values of this ShrinkageOverrides.
        :type: list[ShrinkageOverride]
        """
        
        self._values = values

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

