# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class VoicemailMediaInfo(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        VoicemailMediaInfo - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'id': 'str',
            'media_file_uri': 'str',
            'media_image_uri': 'str',
            'waveform_data': 'list[float]'
        }

        self.attribute_map = {
            'id': 'id',
            'media_file_uri': 'mediaFileUri',
            'media_image_uri': 'mediaImageUri',
            'waveform_data': 'waveformData'
        }

        self._id = None
        self._media_file_uri = None
        self._media_image_uri = None
        self._waveform_data = None

    @property
    def id(self):
        """
        Gets the id of this VoicemailMediaInfo.
        The globally unique identifier for the object.

        :return: The id of this VoicemailMediaInfo.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this VoicemailMediaInfo.
        The globally unique identifier for the object.

        :param id: The id of this VoicemailMediaInfo.
        :type: str
        """
        
        self._id = id

    @property
    def media_file_uri(self):
        """
        Gets the media_file_uri of this VoicemailMediaInfo.


        :return: The media_file_uri of this VoicemailMediaInfo.
        :rtype: str
        """
        return self._media_file_uri

    @media_file_uri.setter
    def media_file_uri(self, media_file_uri):
        """
        Sets the media_file_uri of this VoicemailMediaInfo.


        :param media_file_uri: The media_file_uri of this VoicemailMediaInfo.
        :type: str
        """
        
        self._media_file_uri = media_file_uri

    @property
    def media_image_uri(self):
        """
        Gets the media_image_uri of this VoicemailMediaInfo.


        :return: The media_image_uri of this VoicemailMediaInfo.
        :rtype: str
        """
        return self._media_image_uri

    @media_image_uri.setter
    def media_image_uri(self, media_image_uri):
        """
        Sets the media_image_uri of this VoicemailMediaInfo.


        :param media_image_uri: The media_image_uri of this VoicemailMediaInfo.
        :type: str
        """
        
        self._media_image_uri = media_image_uri

    @property
    def waveform_data(self):
        """
        Gets the waveform_data of this VoicemailMediaInfo.


        :return: The waveform_data of this VoicemailMediaInfo.
        :rtype: list[float]
        """
        return self._waveform_data

    @waveform_data.setter
    def waveform_data(self, waveform_data):
        """
        Sets the waveform_data of this VoicemailMediaInfo.


        :param waveform_data: The waveform_data of this VoicemailMediaInfo.
        :type: list[float]
        """
        
        self._waveform_data = waveform_data

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

