# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class WfmIntradayQueueListing(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        WfmIntradayQueueListing - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'entities': 'list[IntradayQueue]',
            'no_data_reason': 'str'
        }

        self.attribute_map = {
            'entities': 'entities',
            'no_data_reason': 'noDataReason'
        }

        self._entities = None
        self._no_data_reason = None

    @property
    def entities(self):
        """
        Gets the entities of this WfmIntradayQueueListing.


        :return: The entities of this WfmIntradayQueueListing.
        :rtype: list[IntradayQueue]
        """
        return self._entities

    @entities.setter
    def entities(self, entities):
        """
        Sets the entities of this WfmIntradayQueueListing.


        :param entities: The entities of this WfmIntradayQueueListing.
        :type: list[IntradayQueue]
        """
        
        self._entities = entities

    @property
    def no_data_reason(self):
        """
        Gets the no_data_reason of this WfmIntradayQueueListing.


        :return: The no_data_reason of this WfmIntradayQueueListing.
        :rtype: str
        """
        return self._no_data_reason

    @no_data_reason.setter
    def no_data_reason(self, no_data_reason):
        """
        Sets the no_data_reason of this WfmIntradayQueueListing.


        :param no_data_reason: The no_data_reason of this WfmIntradayQueueListing.
        :type: str
        """
        allowed_values = ["NoWeekData", "NoPublishedSchedule", "NoSourceForecast"]
        if no_data_reason.lower() not in map(str.lower, allowed_values):
            # print "Invalid value for no_data_reason -> " + no_data_reason
            self._no_data_reason = "outdated_sdk_version"
        else:
            self._no_data_reason = no_data_reason

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

